/*
 * ShapeSurfaceFillerPreparator.hpp
 *
 *  Created on: Sep 3, 2014
 *      Author: heber
 */

#ifndef SHAPESURFACEFILLERPREPARATOR_HPP_
#define SHAPESURFACEFILLERPREPARATOR_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "BaseFillerPreparator.hpp"

class Shape;
class Vector;

/** ShapeSurfaceFillerPreparator takes a shape and uses Shape::getHomogeneousPointsInVolume()
 * to create a specific number of nodes inside this Shape for filling.
 *
 */
class ShapeSurfaceFillerPreparator :
  public BaseFillerPreparator
{
public:
    ShapeSurfaceFillerPreparator(molecule *_filler);
    ~ShapeSurfaceFillerPreparator();

    void addShapeMesh(
        const Shape &_shape,
        const unsigned int _nodes);

    void addSurfaceInserter(
            const Shape &_shape,
            const Vector &_alignedaxis
            );

   void addSurfaceRandomInserter(
        const Shape &_shape,
        const Vector &_alignedaxis,
        const double _MaxAtomComponent,
        const double _MaxMoleculeComponent
        );
};

#endif /* SHAPESURFACEFILLERPREPARATOR_HPP_ */
